# Called by worldtool:drop_tool/tools/shapes and various other functions
# The main menu for the shape generation tool

function worldtool:ui_shapes/check_tool

execute unless score @s wt.ID matches 1.. run function worldtool:use_tool/assign_id

function worldtool:ui_shapes/remove_tags

function worldtool:ui/open_tool
tag @s add wt.menu.shapes
tag @s add wt.allow_input

function worldtool:technical/common/get_item_data
data remove storage worldtool:storage Temp.ShapeTool
data modify storage worldtool:storage Temp.ShapeTool set from storage worldtool:storage Temp.ItemData.WorldTool

execute if predicate worldtool:shape_tool/shapes/cone run tag @s add wt.shape.cone
execute if predicate worldtool:shape_tool/shapes/cylinder run tag @s add wt.shape.cylinder
execute if predicate worldtool:shape_tool/shapes/sphere run tag @s add wt.shape.sphere

tag @s add wt.setting.diameter
tag @s add wt.setting.precision
tag @s[predicate=worldtool:shape_tool/settings/orientation/down] add wt.setting.orientation.down
tag @s[predicate=worldtool:shape_tool/settings/orientation/up] add wt.setting.orientation.up
tag @s[predicate=worldtool:shape_tool/settings/orientation/south] add wt.setting.orientation.south
tag @s[predicate=worldtool:shape_tool/settings/orientation/north] add wt.setting.orientation.north
tag @s[predicate=worldtool:shape_tool/settings/orientation/west] add wt.setting.orientation.west
tag @s[predicate=worldtool:shape_tool/settings/orientation/east] add wt.setting.orientation.east
execute if entity @s[tag=!wt.shape.sphere] run tag @s add wt.setting.orientation
tag @s add wt.setting.degrees
execute unless entity @s[tag=!wt.shape.cone,tag=!wt.shape.cylinder] run tag @s add wt.setting.length
tag @s add wt.setting.y_rotation
execute unless entity @s[tag=!wt.setting.orientation.north,tag=!wt.setting.orientation.south] run tag @s[tag=!wt.shape.sphere] add wt.setting.z_rotation
execute unless entity @s[tag=!wt.setting.orientation.east,tag=!wt.setting.orientation.west,tag=!wt.shape.sphere] run tag @s add wt.setting.x_rotation
tag @s add wt.setting.hollow
tag @s add wt.setting.keep
tag @s add wt.setting.continuous
tag @s[tag=wt.shape.sphere] add wt.setting.secondary_degrees

execute if score $shapeToolPlugins worldtool matches 1.. run function #worldtool:hooks/ui_shapes/menu/add_tags

scoreboard players set #positions_temp worldtool 0
function worldtool:ui_shapes/update_preview/load

execute if entity @s[tag=wt.shape.cone] run tellraw @s [{"nbt":"Translation.\"info.selected_shape.cone\"","storage": "worldtool:storage","color": "yellow"}," ",{"nbt":"Translation.\"button.change.name\"","storage": "worldtool:storage","color": "green","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.change_shape.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_shape/menu"}}]
execute if entity @s[tag=wt.shape.cylinder] run tellraw @s [{"nbt":"Translation.\"info.selected_shape.cylinder\"","storage": "worldtool:storage","color": "yellow"}," ",{"nbt":"Translation.\"button.change.name\"","storage": "worldtool:storage","color": "green","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.change_shape.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_shape/menu"}}]
execute if entity @s[tag=wt.shape.sphere] run tellraw @s [{"nbt":"Translation.\"info.selected_shape.sphere\"","storage": "worldtool:storage","color": "yellow"}," ",{"nbt":"Translation.\"button.change.name\"","storage": "worldtool:storage","color": "green","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.change_shape.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_shape/menu"}}]
execute if score $shapeToolPlugins worldtool matches 1.. run function #worldtool:hooks/ui_shapes/menu/display_shape

execute if entity @s[tag=wt.setting.precision] store result score #precision_temp worldtool run data get storage worldtool:storage Temp.ShapeTool.ShapeSettings.Precision
execute if entity @s[tag=wt.setting.precision] if score #precision_temp worldtool matches ..-1 run scoreboard players operation #temp worldtool = #precision_temp worldtool
execute if entity @s[tag=wt.setting.precision] if score #precision_temp worldtool matches ..-1 run scoreboard players operation #temp worldtool *= #-1 worldtool

function worldtool:input_data/message/shape_diameter
function worldtool:input_data/message/shape_length
execute if entity @s[tag=wt.setting.precision] if score #precision_temp worldtool matches 0.. run tellraw @s ["",{"nbt":"Translation.\"label.shapes.precision.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.precision.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.help.name\"","storage": "worldtool:storage","color": "aqua","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.precision.description\"","storage": "worldtool:storage"}}}," ",{"nbt":"Translation.\"button.decrease.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.decrease.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_decrease"}},{"score":{"name": "#precision_temp","objective": "worldtool"}},{"nbt":"Translation.\"button.increase.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.increase.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_increase"}},"  ",{"nbt":"Translation.\"button.reset.name\"","storage": "worldtool:storage","color": "dark_purple","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.reset.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_reset"}}]
execute if entity @s[tag=wt.setting.precision] if score #precision_temp worldtool matches ..-1 run tellraw @s ["",{"nbt":"Translation.\"label.shapes.precision.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.precision.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.help.name\"","storage": "worldtool:storage","color": "aqua","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.precision.description\"","storage": "worldtool:storage"}}}," ",{"nbt":"Translation.\"button.decrease.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.decrease.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_decrease"}},{"nbt":"Translation.\"prefix.fraction\"","storage": "worldtool:storage"},{"score":{"name": "#temp","objective": "worldtool"}},{"nbt":"Translation.\"button.increase.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.increase.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_increase"}},"  ",{"nbt":"Translation.\"button.reset.name\"","storage": "worldtool:storage","color": "dark_purple","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.reset.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/precision_reset"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.down] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.down\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.up] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.up\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.south] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.south\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.north] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.north\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.west] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.west\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
execute if entity @s[tag=wt.setting.orientation,tag=wt.setting.orientation.east] run tellraw @s ["",{"nbt":"Translation.\"label.shapes.orientation.name\"","storage": "worldtool:storage","color": "gold","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"label.shapes.orientation.description\"","storage": "worldtool:storage"}}},{"nbt":"Translation.\"button.left.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.left.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_left"}},{"nbt":"Translation.\"orientation.east\"","storage": "worldtool:storage"},{"nbt":"Translation.\"button.right.name\"","storage": "worldtool:storage","color": "light_purple","bold": true,"hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.right.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/orientation_cycle_right"}}]
function worldtool:input_data/message/shape_degrees
function worldtool:input_data/message/shape_secondary_degrees
function worldtool:input_data/message/shape_rotation

execute if score $shapeToolPlugins worldtool matches 1.. run function #worldtool:hooks/ui_shapes/menu/display_settings

tellraw @s ""
tellraw @s[predicate=worldtool:shape_tool/settings/replace/none,predicate=!worldtool:shape_tool/settings/keep] [{"nbt":"Translation.\"button.replace.off_more\"","storage": "worldtool:storage","color": "#d20aff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.replace.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_block/replace"}}," ",{"nbt":"Translation.\"button.keep.off\"","storage": "worldtool:storage","color": "#0aad02","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.keep.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/keep_toggle"}}]
tellraw @s[predicate=worldtool:shape_tool/settings/replace/none,predicate=worldtool:shape_tool/settings/keep] [{"nbt":"Translation.\"button.replace.off_more\"","storage": "worldtool:storage","color": "#d20aff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.replace.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_block/replace"}}," ",{"nbt":"Translation.\"button.keep.on\"","storage": "worldtool:storage","color": "#0aad02","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.keep.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/keep_toggle"}}]
tellraw @s[predicate=!worldtool:shape_tool/settings/replace/none,predicate=worldtool:shape_tool/settings/keep] [{"nbt":"Translation.\"button.replace.on\"","storage": "worldtool:storage","color": "#d20aff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.replace.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/replace_off"}}," ",{"nbt":"Translation.\"button.keep.on\"","storage": "worldtool:storage","color": "#0aad02","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.keep.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/keep_toggle"}}]
tellraw @s[predicate=!worldtool:shape_tool/settings/replace/none,predicate=!worldtool:shape_tool/settings/keep] [{"nbt":"Translation.\"button.replace.on\"","storage": "worldtool:storage","color": "#d20aff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.replace.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/replace_off"}}," ",{"nbt":"Translation.\"button.keep.off\"","storage": "worldtool:storage","color": "#0aad02","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.keep.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/keep_toggle"}}]
tellraw @s[predicate=worldtool:shape_tool/settings/hollow] [{"nbt":"Translation.\"button.select_new_block.name\"","storage": "worldtool:storage","color": "green","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.select_new_block.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_block/normal"}}," ",{"nbt":"Translation.\"button.shapes.hollow.on\"","storage": "worldtool:storage","color": "yellow","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.shapes.hollow.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/hollow_toggle"}}," ",{"nbt":"Translation.\"button.adjust_position.name\"","storage": "worldtool:storage","color": "#3430ff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.adjust_position.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/adjust_position/load"}}]
tellraw @s[predicate=!worldtool:shape_tool/settings/hollow] [{"nbt":"Translation.\"button.select_new_block.name\"","storage": "worldtool:storage","color": "green","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.select_new_block.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/select_block/normal"}}," ",{"nbt":"Translation.\"button.shapes.hollow.off\"","storage": "worldtool:storage","color": "yellow","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.shapes.hollow.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/hollow_toggle"}}," ",{"nbt":"Translation.\"button.adjust_position.name\"","storage": "worldtool:storage","color": "#3430ff","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.adjust_position.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/adjust_position/load"}}]

execute if score #positions_temp worldtool matches 1 run tellraw @s ["\n",{"nbt":"Translation.\"button.run.name\"","storage": "worldtool:storage","color": "yellow","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.generate_shape.enabled.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/start"}}," ",{"nbt":"Translation.\"button.options.name\"","storage": "worldtool:storage","color": "aqua","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.options.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/options/menu"}}," ",{"nbt":"Translation.\"button.cancel.name\"","storage": "worldtool:storage","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.cancel.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui/close"}}]
execute if score #positions_temp worldtool matches 0 run tellraw @s ["\n",{"nbt":"Translation.\"button.run.name\"","storage": "worldtool:storage","color": "gray","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.generate_shape.disabled.description\"","storage": "worldtool:storage"}}}," ",{"nbt":"Translation.\"button.options.name\"","storage": "worldtool:storage","color": "aqua","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.options.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/options/menu"}}," ",{"nbt":"Translation.\"button.cancel.name\"","storage": "worldtool:storage","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.cancel.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui/close"}}]
execute if score #positions_temp worldtool matches 2.. run function worldtool:ui/error/shape_position_duplicates

tellraw @s[predicate=!worldtool:shape_tool/settings/continuous_place] {"nbt":"Translation.\"button.shapes.continuous_place.off\"","storage": "worldtool:storage","color": "light_purple","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.shapes.continuous_place.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/continuous_place_toggle"}}
tellraw @s[predicate=worldtool:shape_tool/settings/continuous_place] {"nbt":"Translation.\"button.shapes.continuous_place.on\"","storage": "worldtool:storage","color": "light_purple","hoverEvent": {"action": "show_text","contents": {"nbt":"Translation.\"button.shapes.continuous_place.description\"","storage": "worldtool:storage"}},"clickEvent": {"action": "run_command","value": "/function worldtool:ui_shapes/settings/continuous_place_toggle"}}

function worldtool:ui_shapes/remove_tags

function worldtool:ui/anti_feedback_chat_message/load
